blob: 278f540eb6b7d5dfd4498b38508d6e899edd4491 [file] [log] [blame]
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +01001#!/bin/bash
2#
3# Runner for an individual run-test.
4
5msg() {
6 if [ "$QUIET" = "n" ]; then
7 echo "$@"
8 fi
9}
10
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +000011ANDROID_ROOT="/system"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010012ARCHITECTURES_32="(arm|x86|mips|none)"
Andreas Gampe1a5c4062015-01-15 12:10:47 -080013ARCHITECTURES_64="(arm64|x86_64|mips64|none)"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010014ARCHITECTURES_PATTERN="${ARCHITECTURES_32}"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +000015BOOT_IMAGE=""
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010016COMPILE_FLAGS=""
17DALVIKVM="dalvikvm32"
18DEBUGGER="n"
19DEV_MODE="n"
20DEX2OAT=""
Alex Light8a0e0332015-10-26 10:11:58 -070021EXPERIMENTAL=""
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010022FALSE_BIN="/system/bin/false"
23FLAGS=""
24GDB=""
Nicolas Geoffraybaf91022014-10-08 09:56:45 +010025GDB_ARGS=""
26GDB_SERVER="gdbserver"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010027HAVE_IMAGE="y"
28HOST="n"
29INTERPRETER="n"
Mathieu Chartiere5f13e52015-02-24 09:37:21 -080030JIT="n"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010031INVOKE_WITH=""
32ISA=x86
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +000033LIBRARY_DIRECTORY="lib"
34MAIN=""
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010035OPTIMIZE="y"
36PATCHOAT=""
37PREBUILD="y"
38QUIET="n"
39RELOCATE="y"
Jeff Hao207a37d2014-10-29 17:24:25 -070040SECONDARY_DEX=""
Hiroshi Yamauchi6ffb9cc2015-08-31 15:14:17 -070041TIME_OUT="gdb" # "n" (disabled), "timeout" (use timeout), "gdb" (use gdb)
42# Value in seconds
Hiroshi Yamauchidcf0d4b2015-09-09 18:59:42 -070043if [ "$ART_USE_READ_BARRIER" = "true" ]; then
44 TIME_OUT_VALUE=900 # 15 minutes.
45else
46 TIME_OUT_VALUE=600 # 10 minutes.
47fi
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010048USE_GDB="n"
Nicolas Geoffray288a4a22014-10-07 11:02:40 +010049USE_JVM="n"
Igor Murashkin7617abd2015-07-10 18:27:47 -070050VERIFY="y" # y=yes,n=no,s=softfail
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010051ZYGOTE=""
Andreas Gampe2b0fa5b2014-10-31 18:12:30 -070052DEX_VERIFY=""
Andreas Gampe65357032015-02-19 15:10:24 -080053USE_DEX2OAT_AND_PATCHOAT="y"
Andreas Gampe4d2ef332015-08-05 09:24:45 -070054INSTRUCTION_SET_FEATURES=""
Mathieu Chartier031768a2015-08-27 10:25:02 -070055ARGS=""
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010056
57while true; do
58 if [ "x$1" = "x--quiet" ]; then
59 QUIET="y"
60 shift
61 elif [ "x$1" = "x--lib" ]; then
62 shift
63 if [ "x$1" = "x" ]; then
64 echo "$0 missing argument to --lib" 1>&2
65 exit 1
66 fi
67 LIB="$1"
68 shift
Alex Light97acf192016-03-17 09:59:38 -070069 elif [ "x$1" = "x--gc-stress" ]; then
70 # Give an extra 5 mins if we are gc-stress.
71 TIME_OUT_VALUE=$((${TIME_OUT_VALUE} + 300))
72 shift
Mathieu Chartier031768a2015-08-27 10:25:02 -070073 elif [ "x$1" = "x--testlib" ]; then
74 shift
75 if [ "x$1" = "x" ]; then
76 echo "$0 missing argument to --testlib" 1>&2
77 exit 1
78 fi
Mathieu Chartierde286fd2015-09-03 18:10:29 -070079 ARGS="${ARGS} $1"
Mathieu Chartier031768a2015-08-27 10:25:02 -070080 shift
David Srbecky52886112016-01-22 13:56:47 +000081 elif [ "x$1" = "x--args" ]; then
82 shift
83 if [ "x$1" = "x" ]; then
84 echo "$0 missing argument to --args" 1>&2
85 exit 1
86 fi
87 ARGS="${ARGS} $1"
88 shift
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010089 elif [ "x$1" = "x-Xcompiler-option" ]; then
90 shift
91 option="$1"
92 FLAGS="${FLAGS} -Xcompiler-option $option"
93 COMPILE_FLAGS="${COMPILE_FLAGS} $option"
94 shift
95 elif [ "x$1" = "x--runtime-option" ]; then
96 shift
97 option="$1"
98 FLAGS="${FLAGS} $option"
99 shift
100 elif [ "x$1" = "x--boot" ]; then
101 shift
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000102 BOOT_IMAGE="$1"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100103 shift
104 elif [ "x$1" = "x--no-dex2oat" ]; then
105 DEX2OAT="-Xcompiler:${FALSE_BIN}"
Andreas Gampe65357032015-02-19 15:10:24 -0800106 USE_DEX2OAT_AND_PATCHOAT="n"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100107 shift
108 elif [ "x$1" = "x--no-patchoat" ]; then
109 PATCHOAT="-Xpatchoat:${FALSE_BIN}"
Andreas Gampe65357032015-02-19 15:10:24 -0800110 USE_DEX2OAT_AND_PATCHOAT="n"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100111 shift
112 elif [ "x$1" = "x--relocate" ]; then
113 RELOCATE="y"
114 shift
115 elif [ "x$1" = "x--no-relocate" ]; then
116 RELOCATE="n"
117 shift
118 elif [ "x$1" = "x--prebuild" ]; then
119 PREBUILD="y"
120 shift
121 elif [ "x$1" = "x--host" ]; then
122 HOST="y"
Nicolas Geoffray8eedb472014-10-29 14:05:59 +0000123 ANDROID_ROOT="$ANDROID_HOST_OUT"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100124 shift
125 elif [ "x$1" = "x--no-prebuild" ]; then
126 PREBUILD="n"
127 shift
128 elif [ "x$1" = "x--no-image" ]; then
129 HAVE_IMAGE="n"
130 shift
Jeff Hao207a37d2014-10-29 17:24:25 -0700131 elif [ "x$1" = "x--secondary" ]; then
132 SECONDARY_DEX=":$DEX_LOCATION/$TEST_NAME-ex.jar"
Calin Juravle175dc732015-08-25 15:42:32 +0100133 # Enable cfg-append to make sure we get the dump for both dex files.
134 # (otherwise the runtime compilation of the secondary dex will overwrite
135 # the dump of the first one)
136 FLAGS="${FLAGS} -Xcompiler-option --dump-cfg-append"
137 COMPILE_FLAGS="${COMPILE_FLAGS} --dump-cfg-append"
Jeff Hao207a37d2014-10-29 17:24:25 -0700138 shift
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100139 elif [ "x$1" = "x--debug" ]; then
140 DEBUGGER="y"
Brian Carlstrom93d6ce52014-11-04 22:31:35 -0800141 TIME_OUT="n"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100142 shift
143 elif [ "x$1" = "x--gdb" ]; then
144 USE_GDB="y"
145 DEV_MODE="y"
Brian Carlstrom93d6ce52014-11-04 22:31:35 -0800146 TIME_OUT="n"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100147 shift
Mathieu Chartierc0a8a802014-10-17 15:58:01 -0700148 elif [ "x$1" = "x--gdb-arg" ]; then
149 shift
150 gdb_arg="$1"
151 GDB_ARGS="${GDB_ARGS} $gdb_arg"
152 shift
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100153 elif [ "x$1" = "x--zygote" ]; then
154 ZYGOTE="-Xzygote"
155 msg "Spawning from zygote"
156 shift
157 elif [ "x$1" = "x--dev" ]; then
158 DEV_MODE="y"
159 shift
160 elif [ "x$1" = "x--interpreter" ]; then
161 INTERPRETER="y"
162 shift
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800163 elif [ "x$1" = "x--jit" ]; then
164 JIT="y"
165 shift
Nicolas Geoffray288a4a22014-10-07 11:02:40 +0100166 elif [ "x$1" = "x--jvm" ]; then
167 USE_JVM="y"
168 shift
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100169 elif [ "x$1" = "x--invoke-with" ]; then
170 shift
171 if [ "x$1" = "x" ]; then
172 echo "$0 missing argument to --invoke-with" 1>&2
173 exit 1
174 fi
175 if [ "x$INVOKE_WITH" = "x" ]; then
176 INVOKE_WITH="$1"
177 else
178 INVOKE_WITH="$INVOKE_WITH $1"
179 fi
180 shift
181 elif [ "x$1" = "x--no-verify" ]; then
182 VERIFY="n"
183 shift
Igor Murashkin7617abd2015-07-10 18:27:47 -0700184 elif [ "x$1" = "x--verify-soft-fail" ]; then
185 VERIFY="s"
186 shift
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100187 elif [ "x$1" = "x--no-optimize" ]; then
188 OPTIMIZE="n"
189 shift
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000190 elif [ "x$1" = "x--android-root" ]; then
191 shift
192 ANDROID_ROOT="$1"
193 shift
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700194 elif [ "x$1" = "x--instruction-set-features" ]; then
195 shift
196 INSTRUCTION_SET_FEATURES="$1"
197 shift
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100198 elif [ "x$1" = "x--" ]; then
199 shift
200 break
201 elif [ "x$1" = "x--64" ]; then
202 ISA="x86_64"
203 GDB_SERVER="gdbserver64"
204 DALVIKVM="dalvikvm64"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000205 LIBRARY_DIRECTORY="lib64"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100206 ARCHITECTURES_PATTERN="${ARCHITECTURES_64}"
207 shift
Andreas Gampec23c9c92014-10-28 14:47:25 -0700208 elif [ "x$1" = "x--pic-test" ]; then
209 FLAGS="${FLAGS} -Xcompiler-option --compile-pic"
210 COMPILE_FLAGS="${COMPILE_FLAGS} --compile-pic"
211 shift
Alex Light8a0e0332015-10-26 10:11:58 -0700212 elif [ "x$1" = "x--experimental" ]; then
213 if [ "$#" -lt 2 ]; then
214 echo "missing --experimental option" 1>&2
215 exit 1
216 fi
217 EXPERIMENTAL="$EXPERIMENTAL $2"
218 shift 2
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100219 elif expr "x$1" : "x--" >/dev/null 2>&1; then
220 echo "unknown $0 option: $1" 1>&2
221 exit 1
222 else
223 break
224 fi
225done
226
Alex Light8a0e0332015-10-26 10:11:58 -0700227if [ "$USE_JVM" = "n" ]; then
228 for feature in ${EXPERIMENTAL}; do
Alex Lightfa022852015-10-28 09:13:20 -0700229 FLAGS="${FLAGS} -Xexperimental:${feature} -Xcompiler-option --runtime-arg -Xcompiler-option -Xexperimental:${feature}"
Alex Light8a0e0332015-10-26 10:11:58 -0700230 COMPILE_FLAGS="${COMPILE_FLAGS} --runtime-arg -Xexperimental:${feature}"
231 done
232fi
233
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100234if [ "x$1" = "x" ] ; then
235 MAIN="Main"
236else
237 MAIN="$1"
Andreas Gampef2fdc732014-06-11 08:20:47 -0700238 shift
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100239fi
240
241if [ "$ZYGOTE" = "" ]; then
242 if [ "$OPTIMIZE" = "y" ]; then
243 if [ "$VERIFY" = "y" ]; then
244 DEX_OPTIMIZE="-Xdexopt:verified"
245 else
246 DEX_OPTIMIZE="-Xdexopt:all"
247 fi
248 msg "Performing optimizations"
249 else
250 DEX_OPTIMIZE="-Xdexopt:none"
251 msg "Skipping optimizations"
252 fi
253
254 if [ "$VERIFY" = "y" ]; then
Nicolas Geoffray288a4a22014-10-07 11:02:40 +0100255 JVM_VERIFY_ARG="-Xverify:all"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100256 msg "Performing verification"
Igor Murashkin7617abd2015-07-10 18:27:47 -0700257 elif [ "$VERIFY" = "s" ]; then
258 JVM_VERIFY_ARG="Xverify:all"
259 DEX_VERIFY="-Xverify:softfail"
260 msg "Forcing verification to be soft fail"
261 else # VERIFY = "n"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100262 DEX_VERIFY="-Xverify:none"
Nicolas Geoffray288a4a22014-10-07 11:02:40 +0100263 JVM_VERIFY_ARG="-Xverify:none"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100264 msg "Skipping verification"
265 fi
266fi
267
268msg "------------------------------"
269
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100270if [ "$DEBUGGER" = "y" ]; then
271 # Use this instead for ddms and connect by running 'ddms':
272 # DEBUGGER_OPTS="-agentlib:jdwp=transport=dt_android_adb,server=y,suspend=y"
273 # TODO: add a separate --ddms option?
274
275 PORT=12345
276 msg "Waiting for jdb to connect:"
277 if [ "$HOST" = "n" ]; then
278 msg " adb forward tcp:$PORT tcp:$PORT"
279 fi
280 msg " jdb -attach localhost:$PORT"
281 DEBUGGER_OPTS="-agentlib:jdwp=transport=dt_socket,address=$PORT,server=y,suspend=y"
282fi
283
Nicolas Geoffray288a4a22014-10-07 11:02:40 +0100284if [ "$USE_JVM" = "y" ]; then
Mathieu Chartiera61894d2015-04-23 16:32:54 -0700285 # Xmx is necessary since we don't pass down the ART flags to JVM.
Andreas Gampe3f1dc562015-05-18 15:52:22 -0700286 cmdline="${JAVA} ${DEBUGGER_OPTS} ${JVM_VERIFY_ARG} -Xmx256m -classpath classes ${FLAGS} $MAIN $@"
287 if [ "$DEV_MODE" = "y" ]; then
288 echo $cmdline
289 fi
290 $cmdline
Nicolas Geoffray288a4a22014-10-07 11:02:40 +0100291 exit
292fi
293
294
295if [ "$HAVE_IMAGE" = "n" ]; then
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000296 DALVIKVM_BOOT_OPT="-Ximage:/system/non-existant/core.art"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000297else
298 DALVIKVM_BOOT_OPT="-Ximage:${BOOT_IMAGE}"
Nicolas Geoffray288a4a22014-10-07 11:02:40 +0100299fi
300
301
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100302if [ "$USE_GDB" = "y" ]; then
303 if [ "$HOST" = "n" ]; then
304 GDB="$GDB_SERVER :5039"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100305 else
306 if [ `uname` = "Darwin" ]; then
307 GDB=lldb
Mathieu Chartierc0a8a802014-10-17 15:58:01 -0700308 GDB_ARGS="$GDB_ARGS -- $DALVIKVM"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100309 DALVIKVM=
310 else
311 GDB=gdb
Mathieu Chartierc0a8a802014-10-17 15:58:01 -0700312 GDB_ARGS="$GDB_ARGS --args $DALVIKVM"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100313 # Enable for Emacs "M-x gdb" support. TODO: allow extra gdb arguments on command line.
314 # gdbargs="--annotate=3 $gdbargs"
315 fi
316 fi
317fi
318
319if [ "$INTERPRETER" = "y" ]; then
Nicolas Geoffraye722d292015-12-15 11:51:37 +0000320 INT_OPTS="-Xint"
Andreas Gampe2b0fa5b2014-10-31 18:12:30 -0700321 if [ "$VERIFY" = "y" ] ; then
322 COMPILE_FLAGS="${COMPILE_FLAGS} --compiler-filter=interpret-only"
Igor Murashkin7617abd2015-07-10 18:27:47 -0700323 elif [ "$VERIFY" = "s" ]; then
324 COMPILE_FLAGS="${COMPILE_FLAGS} --compiler-filter=verify-at-runtime"
325 DEX_VERIFY="${DEX_VERIFY} -Xverify:softfail"
326 else # VERIFY = "n"
Andreas Gampe2b0fa5b2014-10-31 18:12:30 -0700327 COMPILE_FLAGS="${COMPILE_FLAGS} --compiler-filter=verify-none"
328 DEX_VERIFY="${DEX_VERIFY} -Xverify:none"
329 fi
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100330fi
331
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800332if [ "$JIT" = "y" ]; then
Nicolas Geoffraye722d292015-12-15 11:51:37 +0000333 INT_OPTS="-Xusejit:true"
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800334 if [ "$VERIFY" = "y" ] ; then
Mathieu Chartiere86deef2015-03-19 13:43:37 -0700335 COMPILE_FLAGS="${COMPILE_FLAGS} --compiler-filter=verify-at-runtime"
Nicolas Geoffrayc6b1b932016-03-22 09:52:40 +0000336 if [ "$PREBUILD" = "n" ]; then
337 # Make sure that if we have noprebuild we still JIT as DexClassLoader will
338 # try to compile the dex file.
339 INT_OPTS="${INT_OPTS} -Xcompiler-option --compiler-filter=verify-at-runtime"
340 fi
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800341 else
342 COMPILE_FLAGS="${COMPILE_FLAGS} --compiler-filter=verify-none"
343 DEX_VERIFY="${DEX_VERIFY} -Xverify:none"
Nicolas Geoffrayc6b1b932016-03-22 09:52:40 +0000344 if [ "$PREBUILD" = "n" ]; then
345 INT_OPTS="${INT_OPTS} -Xcompiler-option --compiler-filter=verify-none"
346 fi
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800347 fi
348fi
349
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100350JNI_OPTS="-Xjnigreflimit:512 -Xcheck:jni"
351
352if [ "$RELOCATE" = "y" ]; then
353 COMPILE_FLAGS="${COMPILE_FLAGS} --include-patch-information --runtime-arg -Xnorelocate"
354 FLAGS="${FLAGS} -Xrelocate -Xcompiler-option --include-patch-information"
355 if [ "$HOST" = "y" ]; then
356 # Run test sets a fairly draconian ulimit that we will likely blow right over
357 # since we are relocating. Get the total size of the /system/framework directory
358 # in 512 byte blocks and set it as the ulimit. This should be more than enough
359 # room.
360 if [ ! `uname` = "Darwin" ]; then # TODO: Darwin doesn't support "du -B..."
Alex Lightd26b7e42016-04-08 09:44:54 -0700361 ulimit -S $(du -c -B512 ${ANDROID_HOST_OUT}/framework 2>/dev/null | tail -1 | cut -f1) || exit 1
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100362 fi
363 fi
364else
365 FLAGS="$FLAGS -Xnorelocate"
366 COMPILE_FLAGS="${COMPILE_FLAGS} --runtime-arg -Xnorelocate"
Mathieu Chartiercae2ed92015-06-09 13:02:50 -0700367 if [ "$HOST" = "y" ]; then
368 # Increase ulimit to 64MB in case we are running hprof test.
369 ulimit -S 64000 || exit 1
370 fi
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100371fi
372
373if [ "$HOST" = "n" ]; then
374 ISA=$(adb shell ls -F /data/dalvik-cache | grep -Ewo "${ARCHITECTURES_PATTERN}")
375 if [ x"$ISA" = "x" ]; then
376 echo "Unable to determine architecture"
377 exit 1
378 fi
379fi
380
381dex2oat_cmdline="true"
382mkdir_cmdline="mkdir -p ${DEX_LOCATION}/dalvik-cache/$ISA"
383
Andreas Gampe14759242016-03-23 10:54:21 -0700384app_image="--app-image-file=$DEX_LOCATION/oat/$ISA/$TEST_NAME.art"
Jeff Haodcdc85b2015-12-04 14:06:18 -0800385
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100386if [ "$PREBUILD" = "y" ]; then
Andreas Gampe14759242016-03-23 10:54:21 -0700387 mkdir_cmdline="${mkdir_cmdline} && mkdir -p ${DEX_LOCATION}/oat/$ISA"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000388 dex2oat_cmdline="$INVOKE_WITH $ANDROID_ROOT/bin/dex2oatd \
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100389 $COMPILE_FLAGS \
Nicolas Geoffray68e25eb2014-10-29 23:02:11 +0000390 --boot-image=${BOOT_IMAGE} \
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100391 --dex-file=$DEX_LOCATION/$TEST_NAME.jar \
Andreas Gampe14759242016-03-23 10:54:21 -0700392 --oat-file=$DEX_LOCATION/oat/$ISA/$TEST_NAME.odex \
Jeff Haodcdc85b2015-12-04 14:06:18 -0800393 ${app_image} \
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100394 --instruction-set=$ISA"
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700395 if [ "x$INSTRUCTION_SET_FEATURES" != "x" ] ; then
396 dex2oat_cmdline="${dex2oat_cmdline} --instruction-set-features=${INSTRUCTION_SET_FEATURES}"
397 fi
Andreas Gampe2ea7b702015-08-07 08:07:16 -0700398
399 # Add in a timeout. This is important for testing the compilation/verification time of
400 # pathological cases.
401 # Note: as we don't know how decent targets are (e.g., emulator), only do this on the host for
402 # now. We should try to improve this.
403 # The current value is rather arbitrary. run-tests should compile quickly.
404 if [ "$HOST" != "n" ]; then
405 # Use SIGRTMIN+2 to try to dump threads.
406 # Use -k 1m to SIGKILL it a minute later if it hasn't ended.
407 dex2oat_cmdline="timeout -k 1m -s SIGRTMIN+2 1m ${dex2oat_cmdline}"
408 fi
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700409fi
410
411DALVIKVM_ISA_FEATURES_ARGS=""
412if [ "x$INSTRUCTION_SET_FEATURES" != "x" ] ; then
413 DALVIKVM_ISA_FEATURES_ARGS="-Xcompiler-option --instruction-set-features=${INSTRUCTION_SET_FEATURES}"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100414fi
415
Nicolas Geoffrayc5256042015-12-26 19:41:37 +0000416# java.io.tmpdir can only be set at launch time.
417TMP_DIR_OPTION=""
418if [ "$HOST" = "n" ]; then
419 TMP_DIR_OPTION="-Djava.io.tmpdir=/data/local/tmp"
420fi
421
Nicolas Geoffraya73280d2016-02-15 13:05:16 +0000422# We set DumpNativeStackOnSigQuit to false to avoid stressing libunwind.
423# b/27185632
424# b/24664297
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000425dalvikvm_cmdline="$INVOKE_WITH $GDB $ANDROID_ROOT/bin/$DALVIKVM \
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100426 $GDB_ARGS \
427 $FLAGS \
Andreas Gampe2b0fa5b2014-10-31 18:12:30 -0700428 $DEX_VERIFY \
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100429 -XXlib:$LIB \
430 $PATCHOAT \
431 $DEX2OAT \
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700432 $DALVIKVM_ISA_FEATURES_ARGS \
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100433 $ZYGOTE \
434 $JNI_OPTS \
435 $INT_OPTS \
436 $DEBUGGER_OPTS \
437 $DALVIKVM_BOOT_OPT \
Nicolas Geoffrayc5256042015-12-26 19:41:37 +0000438 $TMP_DIR_OPTION \
Nicolas Geoffraya73280d2016-02-15 13:05:16 +0000439 -XX:DumpNativeStackOnSigQuit:false \
Mathieu Chartier031768a2015-08-27 10:25:02 -0700440 -cp $DEX_LOCATION/$TEST_NAME.jar$SECONDARY_DEX $MAIN $ARGS"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100441
Andreas Gampe3ad5d5e2015-02-03 18:26:55 -0800442# Remove whitespace.
443dex2oat_cmdline=$(echo $dex2oat_cmdline)
444dalvikvm_cmdline=$(echo $dalvikvm_cmdline)
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100445
446if [ "$HOST" = "n" ]; then
447 adb root > /dev/null
448 adb wait-for-device
449 if [ "$QUIET" = "n" ]; then
450 adb shell rm -r $DEX_LOCATION
451 adb shell mkdir -p $DEX_LOCATION
452 adb push $TEST_NAME.jar $DEX_LOCATION
453 adb push $TEST_NAME-ex.jar $DEX_LOCATION
454 else
455 adb shell rm -r $DEX_LOCATION >/dev/null 2>&1
456 adb shell mkdir -p $DEX_LOCATION >/dev/null 2>&1
457 adb push $TEST_NAME.jar $DEX_LOCATION >/dev/null 2>&1
458 adb push $TEST_NAME-ex.jar $DEX_LOCATION >/dev/null 2>&1
459 fi
460
Nicolas Geoffrayeb441dd2014-10-31 15:34:50 +0000461 LD_LIBRARY_PATH=
462 if [ "$ANDROID_ROOT" != "/system" ]; then
463 # Current default installation is dalvikvm 64bits and dex2oat 32bits,
464 # so we can only use LD_LIBRARY_PATH when testing on a local
465 # installation.
466 LD_LIBRARY_PATH=$ANDROID_ROOT/$LIBRARY_DIRECTORY
467 fi
468
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100469 # Create a script with the command. The command can get longer than the longest
470 # allowed adb command and there is no way to get the exit status from a adb shell
471 # command.
472 cmdline="cd $DEX_LOCATION && \
473 export ANDROID_DATA=$DEX_LOCATION && \
474 export DEX_LOCATION=$DEX_LOCATION && \
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000475 export ANDROID_ROOT=$ANDROID_ROOT && \
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100476 $mkdir_cmdline && \
Sebastien Hertz7cde48c2015-01-20 16:06:43 +0100477 export LD_LIBRARY_PATH=$LD_LIBRARY_PATH && \
Nicolas Geoffray4f7fdd22015-04-24 11:57:37 +0100478 export PATH=$ANDROID_ROOT/bin:$PATH && \
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100479 $dex2oat_cmdline && \
480 $dalvikvm_cmdline"
481
482 cmdfile=$(tempfile -p "cmd-" -s "-$TEST_NAME")
483 echo "$cmdline" > $cmdfile
484
485 if [ "$DEV_MODE" = "y" ]; then
486 echo $cmdline
487 fi
488
489 if [ "$QUIET" = "n" ]; then
490 adb push $cmdfile $DEX_LOCATION/cmdline.sh
491 else
492 adb push $cmdfile $DEX_LOCATION/cmdline.sh > /dev/null 2>&1
493 fi
494
495 adb shell sh $DEX_LOCATION/cmdline.sh
496
497 rm -f $cmdfile
498else
499 export ANDROID_PRINTF_LOG=brief
Andreas Gampea8780822015-03-13 19:51:09 -0700500
501 # By default, and for prebuild dex2oat, we are interested in errors being logged. In dev mode
502 # we want debug messages.
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100503 if [ "$DEV_MODE" = "y" ]; then
504 export ANDROID_LOG_TAGS='*:d'
505 else
Andreas Gampee4301ff2015-02-17 19:25:29 -0800506 export ANDROID_LOG_TAGS='*:e'
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100507 fi
Andreas Gampea8780822015-03-13 19:51:09 -0700508
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100509 export ANDROID_DATA="$DEX_LOCATION"
Nicolas Geoffray8eedb472014-10-29 14:05:59 +0000510 export ANDROID_ROOT="${ANDROID_ROOT}"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100511 export LD_LIBRARY_PATH="${ANDROID_ROOT}/lib"
512 export DYLD_LIBRARY_PATH="${ANDROID_ROOT}/lib"
513 export PATH="$PATH:${ANDROID_ROOT}/bin"
514
David Srbeckyc9ede382015-06-20 06:03:53 +0100515 # Temporarily disable address space layout randomization (ASLR).
516 # This is needed on the host so that the linker loads core.oat at the necessary address.
517 export LD_USE_LOAD_BIAS=1
518
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100519 cmdline="$dalvikvm_cmdline"
520
Hiroshi Yamauchi6ffb9cc2015-08-31 15:14:17 -0700521 if [ "$TIME_OUT" = "gdb" ]; then
522 if [ `uname` = "Darwin" ]; then
523 # Fall back to timeout on Mac.
524 TIME_OUT="timeout"
Hiroshi Yamauchic823eff2015-09-01 16:21:35 -0700525 elif [ "$ISA" = "x86" ]; then
526 # prctl call may fail in 32-bit on an older (3.2) 64-bit Linux kernel. Fall back to timeout.
527 TIME_OUT="timeout"
Hiroshi Yamauchi6ffb9cc2015-08-31 15:14:17 -0700528 else
529 # Check if gdb is available.
530 gdb --eval-command="quit" > /dev/null 2>&1
531 if [ $? != 0 ]; then
532 # gdb isn't available. Fall back to timeout.
533 TIME_OUT="timeout"
534 fi
535 fi
536 fi
537
538 if [ "$TIME_OUT" = "timeout" ]; then
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100539 # Add timeout command if time out is desired.
Andreas Gampe038bb222015-01-13 19:48:14 -0800540 #
541 # Note: We use nested timeouts. The inner timeout sends SIGRTMIN+2 (usually 36) to ART, which
542 # will induce a full thread dump before abort. However, dumping threads might deadlock,
543 # so the outer timeout sends the regular SIGTERM after an additional minute to ensure
544 # termination (without dumping all threads).
Hiroshi Yamauchi6ffb9cc2015-08-31 15:14:17 -0700545 TIME_PLUS_ONE=$(($TIME_OUT_VALUE + 60))
546 cmdline="timeout ${TIME_PLUS_ONE}s timeout -s SIGRTMIN+2 ${TIME_OUT_VALUE}s $cmdline"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100547 fi
548
549 if [ "$DEV_MODE" = "y" ]; then
550 if [ "$PREBUILD" = "y" ]; then
551 echo "$mkdir_cmdline && $dex2oat_cmdline && $cmdline"
552 elif [ "$RELOCATE" = "y" ]; then
553 echo "$mkdir_cmdline && $cmdline"
554 else
555 echo $cmdline
556 fi
557 fi
558
559 cd $ANDROID_BUILD_TOP
560
David Srbecky2e4afe82016-01-27 18:42:06 +0000561 rm -rf ${DEX_LOCATION}/dalvik-cache/
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100562 $mkdir_cmdline || exit 1
Andreas Gampea8780822015-03-13 19:51:09 -0700563 $dex2oat_cmdline || { echo "Dex2oat failed." >&2 ; exit 2; }
564
565 # For running, we must turn off logging when dex2oat or patchoat are missing. Otherwise we use
566 # the same defaults as for prebuilt: everything when --dev, otherwise errors and above only.
567 if [ "$DEV_MODE" = "y" ]; then
568 export ANDROID_LOG_TAGS='*:d'
569 elif [ "$USE_DEX2OAT_AND_PATCHOAT" = "n" ]; then
570 # All tests would log the error of failing dex2oat/patchoat. Be silent here and only
571 # log fatal events.
572 export ANDROID_LOG_TAGS='*:s'
573 else
574 # We are interested in LOG(ERROR) output.
575 export ANDROID_LOG_TAGS='*:e'
576 fi
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100577
578 if [ "$USE_GDB" = "y" ]; then
579 # When running under gdb, we cannot do piping and grepping...
Dmitriy Ivanovf57874d2014-10-07 13:43:23 -0700580 $cmdline "$@"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100581 else
Hiroshi Yamauchi6ffb9cc2015-08-31 15:14:17 -0700582 if [ "$TIME_OUT" != "gdb" ]; then
583 trap 'kill -INT -$pid' INT
584 $cmdline "$@" 2>&1 & pid=$!
585 wait $pid
586 # Add extra detail if time out is enabled.
587 if [ ${PIPESTATUS[0]} = 124 ] && [ "$TIME_OUT" = "timeout" ]; then
588 echo -e "\e[91mTEST TIMED OUT!\e[0m" >&2
589 fi
590 else
591 # With a thread dump that uses gdb if a timeout.
592 trap 'kill -INT -$pid' INT
593 $cmdline "$@" 2>&1 & pid=$!
594 # Spawn a watcher process.
595 ( sleep $TIME_OUT_VALUE && \
596 echo "##### Thread dump using gdb on test timeout" && \
597 ( gdb -q -p $pid --eval-command="info thread" --eval-command="thread apply all bt" \
598 --eval-command="call exit(124)" --eval-command=quit || \
599 kill $pid )) 2> /dev/null & watcher=$!
600 wait $pid
601 test_exit_status=$?
602 pkill -P $watcher 2> /dev/null # kill the sleep which will in turn end the watcher as well
603 if [ $test_exit_status = 0 ]; then
604 # The test finished normally.
605 exit 0
606 else
607 # The test failed or timed out.
608 if [ $test_exit_status = 124 ]; then
609 # The test timed out.
610 echo -e "\e[91mTEST TIMED OUT!\e[0m" >&2
611 fi
612 fi
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100613 fi
614 fi
615fi